org.h2.expression

## Class ExpressionColumn

- java.lang.Object
- - org.h2.expression.Expression
  - - org.h2.expression.ExpressionColumn

    public class ExpressionColumn
    extends Expression

A expression that represents a column of a table or view.

### Constructor Summary

Constructors
Constructor and Description
`ExpressionColumn(Database database, Column column)`
`ExpressionColumn(Database database, java.lang.String schemaName, java.lang.String tableAlias, java.lang.String columnName)`

### Method Summary

Methods
`void` `createIndexConditions(Session session, TableFilter filter)` Create index conditions if possible and attach them to the table filter.
`java.lang.String` `getAlias()` Get the alias name of a column or SQL expression if it is not an aliased expression.
`Column` `getColumn()`
`java.lang.String` `getColumnName()` Get the column name or alias name of this expression.
`int` `getCost()` Estimate the cost to process the expression.
`int` `getDisplaySize()` Get the display size of this expression.
`Expression` `getNotIfPossible(Session session)` If it is possible, return the negated expression.
`int` `getNullable()` Check whether this expression is a column and can store NULL.
`java.lang.String` `getOriginalColumnName()`
`java.lang.String` `getOriginalTableAliasName()`
`long` `getPrecision()` Get the precision of this expression.
`int` `getScale()` Get the scale of this expression.
`java.lang.String` `getSchemaName()` Get the schema name, or null
`java.lang.String` `getSQL()` Get the SQL statement of this expression.
`TableFilter` `getTableFilter()`
`java.lang.String` `getTableName()` Get the table name, or null
`int` `getType()` Return the data type.
`Value` `getValue(Session session)` Return the resulting value for the current row.
`boolean` `isAutoIncrement()` Check if this is an auto-increment column.
`boolean` `isEverything(ExpressionVisitor visitor)` Check if this expression and all sub-expressions can fulfill a criteria.
`void` `mapColumns(ColumnResolver resolver, int level)` Map the columns of the resolver to expression columns.
`Expression` `optimize(Session session)` Try to optimize the expression.
`void` `setEvaluatable(TableFilter tableFilter, boolean b)` Tell the expression columns whether the table filter can return values now.
`void` `updateAggregate(Session session)` Update an aggregate value.

### Methods inherited from class org.h2.expression.Expression

`addFilterConditions, getBooleanValue, getExpressionColumns, getExpressionColumns, getNonAliasExpression, getTableAlias, isConstant, isValueSet, isWildcard, toString`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Constructor Detail

#### ExpressionColumn

    public ExpressionColumn(Database database,
                    Column column)

#### ExpressionColumn

    public ExpressionColumn(Database database,
                    java.lang.String schemaName,
                    java.lang.String tableAlias,
                    java.lang.String columnName)

### Method Detail

#### getSQL

    public java.lang.String getSQL()

Description copied from class: `Expression`
Get the SQL statement of this expression. This may not always be the original SQL statement, specially after optimization.

Specified by:
  `getSQL` in class `Expression`
Returns:
  the SQL statement

#### getTableFilter

    public TableFilter getTableFilter()

#### mapColumns

    public void mapColumns(ColumnResolver resolver,
                  int level)

Description copied from class: `Expression`
Map the columns of the resolver to expression columns.

Specified by:
  `mapColumns` in class `Expression`
Parameters:
  `resolver` - the column resolver
  `level` - the subquery nesting level

#### optimize

    public Expression optimize(Session session)

Description copied from class: `Expression`
Try to optimize the expression.

Specified by:
  `optimize` in class `Expression`
Parameters:
  `session` - the session
Returns:
  the optimized expression

#### updateAggregate

    public void updateAggregate(Session session)

Description copied from class: `Expression`
Update an aggregate value. This method is called at statement execution time. It is usually called once for each row, but if the expression is used multiple times (for example in the column list, and as part of the HAVING expression) it is called multiple times - the row counter needs to be used to make sure the internal state is only updated once.

Specified by:
  `updateAggregate` in class `Expression`
Parameters:
  `session` - the session

#### getValue

    public Value getValue(Session session)

Description copied from class: `Expression`
Return the resulting value for the current row.

Specified by:
  `getValue` in class `Expression`
Parameters:
  `session` - the session
Returns:
  the result

#### getType

    public int getType()

Description copied from class: `Expression`
Return the data type. The data type may not be known before the optimization phase.

Specified by:
  `getType` in class `Expression`
Returns:
  the type

#### setEvaluatable

    public void setEvaluatable(TableFilter tableFilter,
                      boolean b)

Description copied from class: `Expression`
Tell the expression columns whether the table filter can return values now. This is used when optimizing the query.

Specified by:
  `setEvaluatable` in class `Expression`
Parameters:
  `tableFilter` - the table filter
  `b` - true if the table filter can return value

#### getColumn

    public Column getColumn()

#### getScale

    public int getScale()

Description copied from class: `Expression`
Get the scale of this expression.

Specified by:
  `getScale` in class `Expression`
Returns:
  the scale

#### getPrecision

    public long getPrecision()

Description copied from class: `Expression`
Get the precision of this expression.

Specified by:
  `getPrecision` in class `Expression`
Returns:
  the precision

#### getDisplaySize

    public int getDisplaySize()

Description copied from class: `Expression`
Get the display size of this expression.

Specified by:
  `getDisplaySize` in class `Expression`
Returns:
  the display size

#### getOriginalColumnName

    public java.lang.String getOriginalColumnName()

#### getOriginalTableAliasName

    public java.lang.String getOriginalTableAliasName()

#### getColumnName

    public java.lang.String getColumnName()

Description copied from class: `Expression`
Get the column name or alias name of this expression.

Overrides:
  `getColumnName` in class `Expression`
Returns:
  the column name

#### getSchemaName

    public java.lang.String getSchemaName()

Description copied from class: `Expression`
Get the schema name, or null

Overrides:
  `getSchemaName` in class `Expression`
Returns:
  the schema name

#### getTableName

    public java.lang.String getTableName()

Description copied from class: `Expression`
Get the table name, or null

Overrides:
  `getTableName` in class `Expression`
Returns:
  the table name

#### getAlias

    public java.lang.String getAlias()

Description copied from class: `Expression`
Get the alias name of a column or SQL expression if it is not an aliased expression.

Overrides:
  `getAlias` in class `Expression`
Returns:
  the alias name

#### isAutoIncrement

    public boolean isAutoIncrement()

Description copied from class: `Expression`
Check if this is an auto-increment column.

Overrides:
  `isAutoIncrement` in class `Expression`
Returns:
  true if it is an auto-increment column

#### getNullable

    public int getNullable()

Description copied from class: `Expression`
Check whether this expression is a column and can store NULL.

Overrides:
  `getNullable` in class `Expression`
Returns:
  whether NULL is allowed

#### isEverything

    public boolean isEverything(ExpressionVisitor visitor)

Description copied from class: `Expression`
Check if this expression and all sub-expressions can fulfill a criteria. If any part returns false, the result is false.

Specified by:
  `isEverything` in class `Expression`
Parameters:
  `visitor` - the visitor
Returns:
  if the criteria can be fulfilled

#### getCost

    public int getCost()

Description copied from class: `Expression`
Estimate the cost to process the expression. Used when optimizing the query, to calculate the query plan with the lowest estimated cost.

Specified by:
  `getCost` in class `Expression`
Returns:
  the estimated cost

#### createIndexConditions

    public void createIndexConditions(Session session,
                             TableFilter filter)

Description copied from class: `Expression`
Create index conditions if possible and attach them to the table filter.

Overrides:
  `createIndexConditions` in class `Expression`
Parameters:
  `session` - the session
  `filter` - the table filter

#### getNotIfPossible

    public Expression getNotIfPossible(Session session)

Description copied from class: `Expression`
If it is possible, return the negated expression. This is used to optimize NOT expressions: NOT ID>10 can be converted to ID<=10. Returns null if negating is not possible.

Overrides:
  `getNotIfPossible` in class `Expression`
Parameters:
  `session` - the session
Returns:
  the negated expression, or null